<template>
  <div class="rolemanagement">
    <div class="deviceBox">
      <div class="deviceBtnGroup">
        <h4>角色管理</h4>
        <el-button type="primary" icon="el-icon-plus" @click="handleAdddevice()"
          >新增</el-button
        >
      </div>
      <div class="deviceTable">
        <el-table
          ref="multipleTable"
          :data="roleTableData"
          stripe
          tooltip-effect="dark"
          style="width: 100%"
          height="calc(100% - 40px)"
          @row-click="handleRowClick"
        >
          <template slot="empty">
            <el-empty :image-size="160" description="暂无数据"></el-empty>
          </template>
          <el-table-column
            label="ID"
            show-overflow-tooltip
            prop="id"
          ></el-table-column>
          <el-table-column
            label="角色"
            show-overflow-tooltip
            prop="name"
          ></el-table-column>
          <el-table-column
            label="备注"
            show-overflow-tooltip
            prop="desc"
          ></el-table-column>
          <el-table-column
            label="创建时间"
            show-overflow-tooltip
            prop="createTime"
          >
            <template slot-scope="scope" v-if="scope.row.createTime !== null">{{
              $moment(scope.row.createTime).format("yy-MM-DD HH:mm:ss")
            }}</template>
          </el-table-column>
          <el-table-column fixed="right" label="操作" width="200">
            <template slot-scope="scope" v-if="scope.row.id !== 0">
              <el-button
                @click.native.stop="handleResive(scope.row)"
                type="text"
                >修改</el-button
              >
              <el-button
                @click.native.stop="handleMenuBlind(scope.row)"
                type="text"
                >菜单功能分配</el-button
              >
              <el-button
                type="text"
                class="deleteText"
                @click.native.stop="handleDelete(scope.row)"
                >删除</el-button
              >
            </template>
          </el-table-column>
        </el-table>
        <!-- <div class="pageNation">
          <el-pagination
            @current-change="handleCurrentChange"
            @size-change="handleSizeChange"
            :current-page="page"
            :page-size="pageSize"
            layout="sizes, prev, pager, next, jumper,total"
            :total="total"
            background
          >
          </el-pagination>
        </div> -->
      </div>
    </div>
    <!-- 新增 -->
    <addRole :title="title" ref="adduserref"></addRole>
    <!-- 权限绑定 -->
    <blindMenuPermiss ref="blindMenuPermissRef"></blindMenuPermiss>
  </div>
</template>
<script>
import addRole from "./components/addRole.vue";
import blindMenuPermiss from "./components/blindMenuPermiss.vue";
import { getRoleList, deleteRole } from "@/utils/api/index";

export default {
  name: "roleManagement",
  components: {
    addRole,
    blindMenuPermiss,
  },
  data() {
    return {
      title: "", //弹窗标题
      roleTableData: [],
      //multipleSelection: [], //获取当前选中
      page: 1, // 当前页数
      pageSize: 20, // 每页数量
      total: 0, //总条数
    };
  },
  created() {
    this.roleListAll();
  },
  methods: {
    //获取角色数据
    roleListAll() {
      getRoleList()
        .then((res) => {
          this.roleTableData = res.data;
          this.total = res.data.total;
        })
        .catch((err) => {});
    },
    //点击行选中
    handleRowClick(row, column, event) {
      this.$refs.multipleTable.toggleRowSelection(row);
    },
    //获取选中的行
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    // 新建
    handleAdddevice() {
      this.title = "新增";
      this.$refs.adduserref.display();
      this.$refs.adduserref.getdataform(null);
    },

    //修改
    handleResive(data) {
      this.title = "修改";
      this.$refs.adduserref.display();
      this.$refs.adduserref.getdataform(data);
    },
    //菜单资源分配
    handleMenuBlind(row) {
      console.log(row);
      this.$refs.blindMenuPermissRef.display();
      this.$refs.blindMenuPermissRef.getdataform(row);
    },

    //删除数据
    handleDelete(data) {
      console.log(data);
      this.$confirm("确定要删除记录吗,同时删除关联关系?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          deleteRole({ id: data.id }).then((res) => {
            console.log(res.code);
            if (res.code == 200) {
              this.$message.success("删除成功");
              this.roleListAll(); //刷新
            } else if (res.code == 400) {
              this.$message.error(res.msg);
            }
          });
        })
        .catch(() => {
          this.$message({
            duration: 1500,
            showClose: true,
            type: "info",
            message: "已取消删除",
          });
        });
    },
    //点击分页
    handleCurrentChange(val) {
      this.page = val;
      this.roleListAll();
    },
    //每页条数
    handleSizeChange(val) {
      this.pageSize = val;
      this.roleListAll();
    },
  },
};
</script>
<style lang="less">
.rolemanagement {
  width: calc(100% - 24px);
  height: calc(100% - 24px);
  padding: 12px 12px;
  background: #fff;

  .deviceBox {
    border: 1px solid #dddddd;
    height: calc(100% - 24px);
    padding: 12px;
    border-radius: 4px;
  }
  .deviceBtnGroup {
    display: flex;
    justify-content: space-between;
    align-items: center;
  }

  .deviceTable {
    margin-top: 16px;
    height: calc(100% - 48px);
    //background: #fcc;
  }
}
</style>
../user/components/blindPermiss.vue
